# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AutomationSettingArgs', 'AutomationSetting']

@pulumi.input_type
class AutomationSettingArgs:
    def __init__(__self__, *,
                 fabric_sync: Optional[pulumi.Input[str]] = None,
                 max_concurrent_stitches: Optional[pulumi.Input[int]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a AutomationSetting resource.
        """
        if fabric_sync is not None:
            pulumi.set(__self__, "fabric_sync", fabric_sync)
        if max_concurrent_stitches is not None:
            pulumi.set(__self__, "max_concurrent_stitches", max_concurrent_stitches)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="fabricSync")
    def fabric_sync(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "fabric_sync")

    @fabric_sync.setter
    def fabric_sync(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fabric_sync", value)

    @property
    @pulumi.getter(name="maxConcurrentStitches")
    def max_concurrent_stitches(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "max_concurrent_stitches")

    @max_concurrent_stitches.setter
    def max_concurrent_stitches(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_concurrent_stitches", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _AutomationSettingState:
    def __init__(__self__, *,
                 fabric_sync: Optional[pulumi.Input[str]] = None,
                 max_concurrent_stitches: Optional[pulumi.Input[int]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AutomationSetting resources.
        """
        if fabric_sync is not None:
            pulumi.set(__self__, "fabric_sync", fabric_sync)
        if max_concurrent_stitches is not None:
            pulumi.set(__self__, "max_concurrent_stitches", max_concurrent_stitches)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="fabricSync")
    def fabric_sync(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "fabric_sync")

    @fabric_sync.setter
    def fabric_sync(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fabric_sync", value)

    @property
    @pulumi.getter(name="maxConcurrentStitches")
    def max_concurrent_stitches(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "max_concurrent_stitches")

    @max_concurrent_stitches.setter
    def max_concurrent_stitches(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_concurrent_stitches", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class AutomationSetting(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 fabric_sync: Optional[pulumi.Input[str]] = None,
                 max_concurrent_stitches: Optional[pulumi.Input[int]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a AutomationSetting resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[AutomationSettingArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a AutomationSetting resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param AutomationSettingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AutomationSettingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 fabric_sync: Optional[pulumi.Input[str]] = None,
                 max_concurrent_stitches: Optional[pulumi.Input[int]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AutomationSettingArgs.__new__(AutomationSettingArgs)

            __props__.__dict__["fabric_sync"] = fabric_sync
            __props__.__dict__["max_concurrent_stitches"] = max_concurrent_stitches
            __props__.__dict__["vdomparam"] = vdomparam
        super(AutomationSetting, __self__).__init__(
            'fortios:index/automationSetting:AutomationSetting',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            fabric_sync: Optional[pulumi.Input[str]] = None,
            max_concurrent_stitches: Optional[pulumi.Input[int]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'AutomationSetting':
        """
        Get an existing AutomationSetting resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AutomationSettingState.__new__(_AutomationSettingState)

        __props__.__dict__["fabric_sync"] = fabric_sync
        __props__.__dict__["max_concurrent_stitches"] = max_concurrent_stitches
        __props__.__dict__["vdomparam"] = vdomparam
        return AutomationSetting(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="fabricSync")
    def fabric_sync(self) -> pulumi.Output[str]:
        return pulumi.get(self, "fabric_sync")

    @property
    @pulumi.getter(name="maxConcurrentStitches")
    def max_concurrent_stitches(self) -> pulumi.Output[int]:
        return pulumi.get(self, "max_concurrent_stitches")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "vdomparam")

